<template>
	<div class="formulario">
		<form method="POST" @submit.prevent @submit="modificarData()">
			<label for="nombre">Nombre: </label>
			<input
				type="text"
				id="nombre"
				name="nombre"
				required
				v-model="pelicula.nombre"
			/>

			<label for="generoId">Género: </label>
			<select name="generoId" id="generoId" v-model="pelicula.generoId">
				<option v-for="genero in generos" :value="genero.id" :key="genero.id">{{
					genero.nombre
				}}</option>
			</select>

			<label for="anioLanzamiento">Año de Lanzamiento: </label>
			<input
				type="text"
				id="anioLanzamiento"
				name="anioLanzamiento"
				required
				v-model="pelicula.anioLanzamiento"
			/>

			<label for="imagenSd">Imagen SD: </label>
			<input
				type="text"
				id="imagenSd"
				name="imagenSd"
				required
				v-model="pelicula.imagenSd"
			/>

			<label for="imagenHd">Imagen HD: </label>
			<input
				type="text"
				id="imagenHd"
				name="imagenHd"
				required
				v-model="pelicula.imagenHd"
			/>

			<label for="descripcion">Descripción: </label>
			<input
				type="text"
				id="descripcion"
				name="descripcion"
				required
				v-model="pelicula.descripcion"
			/>

			<input type="submit" class="boton" value="Guardar" />

			<router-link class="boton" :to="{ name: 'Principal' }">
				Volver
			</router-link>
		</form>

		<div class="mensajes">{{ mensaje }}</div>
	</div>
</template>

<script>
import axios from "axios";
export default {
	name: "Modificar",
	data() {
		return {
			mensaje: "",
			pelicula: {},
			id: this.$route.params.id,
			generos: [],
		};
	},
	mounted() {
		this.cargarPelicula();
		this.cargarGeneros();
	},
	methods: {
		cargarGeneros() {
			axios.get("http://localhost:8080/api/genero").then((response) => {
				this.generos = response.data;
			});
		},
		cargarPelicula: function() {
			axios
				.get("http://localhost:8080/api/pelicula/" + this.id)
				.then((response) => {
					console.log(response);
					this.pelicula = response.data;
				});
		},
		modificarData() {
			let config = {
				headers: {
					"Content-Type": "application/json",
					"Access-Control-Allow-Origin": "*",
				},
			};

			axios
				.patch(
					"http://localhost:8080/api/pelicula/" + this.pelicula.id,
					null,
					{ params: this.pelicula },
					config
				)
				.then((response) => {
					if (response.status === 200) {
						this.mensaje = response.data;
					}
				});
		},
	},
};
</script>

<style lang="scss" scoped>
.formulario {
	width: 500px;
	margin: 0 auto;
	padding-top: 30px;
	color: #ffffff;

	form {
		box-sizing: border-box;
		display: flex;
		flex-direction: column;
		justify-content: center;
		align-items: center;
		padding: 10px;
		width: 100%;

		select,
		input {
			-webkit-appearance: none;
			border: 1px solid black;
			margin: 20px 0;
			padding: 10px;
			border-radius: 0;
			width: 100%;
		}

		a,
		input[type="submit"] {
			width: 200px;
		}
	}
}
</style>
